%option c++ 8bit noyywrap nostack yymore nodefault
%option outfile="OzScanner.C" prefix="zy"
float ~?{digit}+"."{digit}*([eE]~?{digit}+)?
string \"({stringChar}|{pseudoChar})*\"
variableQuoted `({variableChar}|{pseudoChar})*`
variable {upper}{alphaNum}*
fdin "::"|":::"
compare "<"|">"|"=<"|">="|"\\="
othermul div|mod
fdmul "*"|"/"
add "+"|"-"
%x LEX
regexChar "["([^\]\\]|\\.)+"]"|\"[^"]+\"|\\.|[^<>"\[\]\\\n]
%x DIRECTIVE_FATHER
%x DIRECTIVEWITHARGS
%x DIRECTIVE
%x PARSEREXPECT
%x SCANNERPREFIX
%x LINE
%x IFNDEF
%x IFDEF
%x UNDEF
%x DEFINE
%x INSERT
%x SWITCH
int ~?(0{oct}*|0[Xx]{hex}+|0[Bb]{bin}+|{nonzerodigit}{digit}*)
atomQuoted "'"({atomChar}|{pseudoChar})*"'"
atom {lower}{alphaNum}*
anyChar {char}|{pseudoChar}
pseudoChar \\({oct}{3}|[xX]{hex}{2}|{escape})
hex [0-9a-fA-F]
oct [0-7]
bin [0-1]
escape [abfnrtv\\'\"`&]
stringChar [^\"\\\x00]
atomChar [^'\\\x00]
variableChar [^`\\\x00]
char [^\\\x00]
alphaNum {lower}|{upper}|{digit}|_
nonzerodigit [1-9]
digit [0-9]
upper [A-Z\300-\326\330-\336]
lower [a-z\337-\366\370-\377]
spacenonl [?\t\v\f\r ]
space [?\t\n\v\f\r ]
filename [A-Za-z0-9/_~.-]+|\'[ -~]+\'
blank [ \r\t]
%x COMMENT
%%
<INITIAL,LEX>"%".*\n return 1;
<INITIAL,LEX>"/*" return 2;
<COMMENT>"/*" return 3;
<COMMENT>"*/" return 4;
<COMMENT>[^*/\n]+ return 5;
<COMMENT>\n return 6;
<COMMENT>[*/] return 7;
<COMMENT><<EOF>> return 8;
<INITIAL,LEX>\\switch return 9;
<SWITCH>"+" return 10;
<SWITCH>"-" return 11;
<SWITCH>{alphaNum}+ return 12;
<INITIAL,LEX>\\showSwitches return 13;
<INITIAL,LEX>\\pushSwitches return 14;
<INITIAL,LEX>\\popSwitches return 15;
<INITIAL,LEX>\\localSwitches return 16;
<INITIAL,LEX>\\insert return 17;
<INSERT>{filename} return 18;
<INITIAL,LEX>\\define return 19;
<DEFINE>{variable} return 20;
<INITIAL,LEX>\\undef return 21;
<UNDEF>{variable} return 22;
<INITIAL,LEX>\\ifdef return 23;
<IFDEF>{variable} return 24;
<INITIAL,LEX>\\ifndef return 25;
<IFNDEF>{variable} return 26;
<INITIAL,LEX>\\else return 27;
<INITIAL,LEX>\\endif return 28;
<INITIAL,LEX>\\line return 29;
<LINE>[0-9]+ return 30;
<LINE>{filename} return 31;
<INITIAL,LEX>\\gumpscannerprefix return 32;
<SCANNERPREFIX>{atom} return 33;
<SCANNERPREFIX>{atomQuoted} return 34;
<INITIAL,LEX>\\gumpparserexpect return 35;
<PARSEREXPECT>{int} return 36;
<DIRECTIVE,SWITCH><<EOF>> return 37;
<DIRECTIVEWITHARGS,INSERT,DEFINE,UNDEF,IFDEF,IFNDEF,LINE,SCANNERPREFIX,PARSEREXPECT><<EOF>> return 38;
<DIRECTIVE_FATHER,SWITCH,INSERT,DEFINE,UNDEF,IFDEF,IFNDEF,LINE,SCANNERPREFIX,PARSEREXPECT,DIRECTIVE,DIRECTIVEWITHARGS>"%".*\n return 39;
<DIRECTIVE_FATHER,SWITCH,INSERT,DEFINE,UNDEF,IFDEF,IFNDEF,LINE,SCANNERPREFIX,PARSEREXPECT,DIRECTIVE,DIRECTIVEWITHARGS>"/*" return 40;
<DIRECTIVE_FATHER,SWITCH,INSERT,DEFINE,UNDEF,IFDEF,IFNDEF,LINE,SCANNERPREFIX,PARSEREXPECT,DIRECTIVE,DIRECTIVEWITHARGS>{blank}+ return 41;
<DIRECTIVE_FATHER,SWITCH,INSERT,DEFINE,UNDEF,IFDEF,IFNDEF,LINE,SCANNERPREFIX,PARSEREXPECT,DIRECTIVE,DIRECTIVEWITHARGS>. return 42;
<DIRECTIVE_FATHER,SWITCH,INSERT,DEFINE,UNDEF,IFDEF,IFNDEF,LINE,SCANNERPREFIX,PARSEREXPECT,DIRECTIVE,DIRECTIVEWITHARGS>\n return 43;
<INITIAL,LEX>"=>" return 44;
<INITIAL,LEX>"//" return 45;
<INITIAL,LEX>lex return 46;
<INITIAL,LEX>mode return 47;
<INITIAL,LEX>parser return 48;
<INITIAL,LEX>prod return 49;
<INITIAL,LEX>scanner return 50;
<INITIAL,LEX>syn return 51;
<INITIAL,LEX>token return 52;
<INITIAL,LEX>lex/\( return 53;
<INITIAL,LEX>mode/\( return 54;
<INITIAL,LEX>parser/\( return 55;
<INITIAL,LEX>prod/\( return 56;
<INITIAL,LEX>scanner/\( return 57;
<INITIAL,LEX>syn/\( return 58;
<INITIAL,LEX>token/\( return 59;
<LEX>"<<EOF>>" return 60;
<LEX>"<"{regexChar}+">" return 61;
<INITIAL,LEX>else return 62;
<INITIAL,LEX>elseof return 63;
<INITIAL,LEX>finally return 64;
<INITIAL,LEX>in return 65;
<INITIAL,LEX>of return 66;
<INITIAL,LEX>then return 67;
<INITIAL,LEX>else/\( return 68;
<INITIAL,LEX>elseof/\( return 69;
<INITIAL,LEX>finally/\( return 70;
<INITIAL,LEX>in/\( return 71;
<INITIAL,LEX>of/\( return 72;
<INITIAL,LEX>then/\( return 73;
<INITIAL,LEX>andthen return 74;
<INITIAL,LEX>at return 75;
<INITIAL,LEX>attr return 76;
<INITIAL,LEX>case return 77;
<INITIAL,LEX>catch return 78;
<INITIAL,LEX>choice return 79;
<INITIAL,LEX>class return 80;
<INITIAL,LEX>cond return 81;
<INITIAL,LEX>declare return 82;
<INITIAL,LEX>define return 83;
<INITIAL,LEX>dis return 84;
<INITIAL,LEX>elsecase return 85;
<INITIAL,LEX>elseif return 86;
<INITIAL,LEX>end return 87;
<INITIAL,LEX>export return 88;
<INITIAL,LEX>fail return 89;
<INITIAL,LEX>false return 90;
<INITIAL,LEX>feat return 91;
<INITIAL,LEX>from return 92;
<INITIAL,LEX>fun return 93;
<INITIAL,LEX>functor return 94;
<INITIAL,LEX>if return 95;
<INITIAL,LEX>import return 96;
<INITIAL,LEX>local return 97;
<INITIAL,LEX>lock return 98;
<INITIAL,LEX>meth return 99;
<INITIAL,LEX>not return 100;
<INITIAL,LEX>or return 101;
<INITIAL,LEX>orelse return 102;
<INITIAL,LEX>prepare return 103;
<INITIAL,LEX>proc return 104;
<INITIAL,LEX>prop return 105;
<INITIAL,LEX>require return 106;
<INITIAL,LEX>raise return 107;
<INITIAL,LEX>self return 108;
<INITIAL,LEX>skip return 109;
<INITIAL,LEX>thread return 110;
<INITIAL,LEX>true return 111;
<INITIAL,LEX>try return 112;
<INITIAL,LEX>unit return 113;
<INITIAL,LEX>andthen/\( return 114;
<INITIAL,LEX>at/\( return 115;
<INITIAL,LEX>attr/\( return 116;
<INITIAL,LEX>catch/\( return 117;
<INITIAL,LEX>case/\( return 118;
<INITIAL,LEX>choice/\( return 119;
<INITIAL,LEX>class/\( return 120;
<INITIAL,LEX>cond/\( return 121;
<INITIAL,LEX>declare/\( return 122;
<INITIAL,LEX>define/\( return 123;
<INITIAL,LEX>dis/\( return 124;
<INITIAL,LEX>elsecase/\( return 125;
<INITIAL,LEX>elseif/\( return 126;
<INITIAL,LEX>end/\( return 127;
<INITIAL,LEX>export/\( return 128;
<INITIAL,LEX>fail/\( return 129;
<INITIAL,LEX>false/\( return 130;
<INITIAL,LEX>feat/\( return 131;
<INITIAL,LEX>from/\( return 132;
<INITIAL,LEX>fun/\( return 133;
<INITIAL,LEX>functor/\( return 134;
<INITIAL,LEX>if/\( return 135;
<INITIAL,LEX>import/\( return 136;
<INITIAL,LEX>local/\( return 137;
<INITIAL,LEX>lock/\( return 138;
<INITIAL,LEX>meth/\( return 139;
<INITIAL,LEX>not/\( return 140;
<INITIAL,LEX>or/\( return 141;
<INITIAL,LEX>orelse/\( return 142;
<INITIAL,LEX>prepare/\( return 143;
<INITIAL,LEX>proc/\( return 144;
<INITIAL,LEX>prop/\( return 145;
<INITIAL,LEX>require/\( return 146;
<INITIAL,LEX>raise/\( return 147;
<INITIAL,LEX>self/\( return 148;
<INITIAL,LEX>skip/\( return 149;
<INITIAL,LEX>thread/\( return 150;
<INITIAL,LEX>true/\( return 151;
<INITIAL,LEX>try/\( return 152;
<INITIAL,LEX>unit/\( return 153;
<INITIAL,LEX>{add} return 154;
<INITIAL,LEX>{fdmul} return 155;
<INITIAL,LEX>{othermul} return 156;
<INITIAL,LEX>{othermul}/\( return 157;
<INITIAL,LEX>"=="|{compare} return 158;
<INITIAL,LEX>{fdin} return 159;
<INITIAL,LEX>(=|{compare}): return 160;
<INITIAL,LEX>"..." return 161;
<INITIAL,LEX>"[]" return 162;
<INITIAL,LEX>"!!" return 163;
<INITIAL,LEX>"<-" return 164;
<INITIAL,LEX>"<=" return 165;
<INITIAL,LEX>"{"|"["|"|"|"#"|"="|"."|"^"|"@"|"$"|"!"|"~"|"_"|"," return 166;
<INITIAL,LEX>"}"|"("|")"|"]"|":" return 167;
<INITIAL,LEX>{variable} return 168;
<INITIAL,LEX>{variableQuoted} return 169;
<INITIAL,LEX>{variable}/\( return 170;
<INITIAL,LEX>{variableQuoted}/\( return 171;
<INITIAL,LEX>{atom} return 172;
<INITIAL,LEX>{atomQuoted} return 173;
<INITIAL,LEX>{atom}/\( return 174;
<INITIAL,LEX>{atomQuoted}/\( return 175;
<INITIAL,LEX>{string} return 176;
<INITIAL,LEX>{int} return 177;
<INITIAL,LEX>"."{space}*{digit}+ return 178;
<INITIAL,LEX>{digit}+/\.\.\. return 179;
<INITIAL,LEX>{float} return 180;
<INITIAL,LEX>"&"{anyChar} return 181;
<INITIAL,LEX>{spacenonl}+ return 182;
<INITIAL,LEX>\n+ return 183;
<INITIAL,LEX>\'[^']+\' return 184;
<INITIAL,LEX>`[^`]*` return 185;
<INITIAL,LEX>\"[^"]+\" return 186;
<INITIAL,LEX>. return 187;
<INITIAL,LEX><<EOF>> return 188;
%%
#include "lexer.h"
